import 'dart:io';
import 'constants.dart';
import 'adfurikun_plugin.dart';

class AdfurikunSdk {
  // 広告音の出力設定（true: 音有り、false: 音無し）
  static void setSoundState(bool state) {
    AdfurikunPlugin.invoke(METHOD_SET_SOUND_STATE, {KEY_BOOL: state});
  }

  // テスト広告モード設定（true: テスト広告、false: 本番広告）
  static void setTestMode(bool mode) {
    AdfurikunPlugin.invoke(METHOD_SET_TEST_MODE, {KEY_BOOL: mode});
  }

  // デバッグモード設定（true: ON、false: OFF）
  static void setDebugMode(bool mode) {
    AdfurikunPlugin.invoke(METHOD_SET_DEBUG_MODE, {KEY_BOOL: mode});
  }

  // ユーザーGDPR同意の設定（true: 同意する、false: 同意しない）
  static void setUserConsent(bool hasUserConsent) {
    AdfurikunPlugin.invoke(METHOD_SET_USER_CONSENT, {KEY_BOOL: hasUserConsent});
  }

  // ユーザーCOPPAの設定（true: 同意する、false: 同意しない）
  static void setChildDirected(bool isChildDirected) {
    AdfurikunPlugin.invoke(METHOD_SET_CHILD_DIRECTED, {KEY_BOOL: isChildDirected});
  }

  // (Androidのみ) Googleファミリーポリシーの設定（true: 同意する、false: 同意しない）
  static void setGoogleFamiliesPolicy(bool isGoogleFamiliesPolicy) {
    if (Platform.isAndroid) {
      AdfurikunPlugin.invoke(METHOD_SET_GOOGLE_FAMILIES_POLICY, {KEY_BOOL: isGoogleFamiliesPolicy});
    }
  }

  // 地域の設定
  static void setRegion(AdfurikunOptionsRegion region) {
    AdfurikunPlugin.invoke(METHOD_SET_REGION, {KEY_STRING: region.name});
  }

  // アドフリくんSDKバージョン
  static Future<String> version() async {
    return await AdfurikunPlugin.invokeReturnString(METHOD_VERSION);
  }

  // (iOSのみ) 詳細なデバッグログを出力する
  static void outputDetailedLog() {
    if (Platform.isIOS) {
      AdfurikunPlugin.invoke(METHOD_OUTPUT_DETAILED_LOG, {});
    }
  }
}

enum AdfurikunOptionsRegion {
  DEVICE, // 端末の設定を使う
  JAPAN,  // 地域を日本として設定
  FOREIGN // 地域を海外として設定
}
